"use strict";

undefined;
undefined;

var Future = function Future() {
  this.slots = [];
};

module.exports = Future;

Future.proptotype.ready = function (slot) {
  if (this.completed) {
    slot(this.value);
  } else {
    this.slots.push(slot);
  }
};

Future.proptotype.complete = function (val) {
  if (this.completed) {
    throw "Can not complete a completed Future";
  }

  this.value = val;
  this.completed = true;
  this.slots.forEach(function (slot) {
    slot(value);
  });
  this.slots = null;
};

Future.unit = function (val) {
  var fut = new Future();
  fut.completed(val);
  return fut;
};

Future.delay = function (v, millis) {
  var f = new Future();
  setTimeout(function () {
    f.complete(v);
  }, millis);
  return f;
};

Future.proptotype.fmap = function (fn) {
  var fut = new Future();
  this.ready(function (val) {
    fut.complete(fn(val));
  });
  return fut;
};