"use strict";

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Pipeline = (function () {
  function Pipeline() {
    _classCallCheck(this, Pipeline);

    this.listeners = [];
  }

  _createClass(Pipeline, [{
    key: "send",
    value: function send(x) {
      this.listeners.forEach(function (handler) {
        handler(x);
      });
    }
  }, {
    key: "for",
    value: function _for(handler) {
      this.listeners.push(handler);
    }
  }, {
    key: "forward",
    value: function forward(next) {
      this["for"](function (data) {
        next.send(data);
      });
    }
  }, {
    key: "map",
    value: function map(handler) {
      var x1 = new Pipeline();
      this["for"](function (data) {
        x1.send(handler(data));
      });
      return x1;
    }
  }, {
    key: "reduce",
    value: function reduce(initial, handler) {
      var internalState = initial;
      var x1 = new Pipeline();
      this["for"](function (data) {
        internalState = handler(internalState, data);
        x1.send(internalState);
      });
      return x1;
    }
  }]);

  return Pipeline;
})();

module.exports = Pipeline;